package com.jz.dmp.cmdexectool.controller.bean;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;

import com.jz.dmp.cmdexectool.common.constant.CommConstant;
import com.jz.dmp.cmdexectool.entity.DmpDevelopTask;
import com.jz.dmp.cmdexectool.scheduler.common.enums.JobType;
import com.jz.dmp.cmdexectool.scheduler.common.task.shell.ShellParameters;
import com.jz.dmp.cmdexectool.scheduler.dao.entity.TaskInstance;
import com.jz.dmp.cmdexectool.scheduler.server.entity.TaskExecutionContext;

public class MyDmpDevelopTaskConverter {
	
	private static MyDmpDevelopTaskConverter instance;
	
	private MyDmpDevelopTaskConverter() {};
	
	public synchronized static MyDmpDevelopTaskConverter INSTANCE() {
		if (instance==null) {
			instance = new MyDmpDevelopTaskConverter();
		}
		
		return instance;
	}
	
	public DmpDevelopTaskDto domain2dto(DmpDevelopTask dmpDevelopTask) {
		DmpDevelopTaskDto dmpDevelopTaskDto = new DmpDevelopTaskDto();
		BeanUtils.copyProperties(dmpDevelopTask, dmpDevelopTaskDto);
		
		return dmpDevelopTaskDto;
	}
	
	public List<DmpDevelopTaskDto> domain2dto(List<DmpDevelopTask> dmpDevelopTasks) {
		List<DmpDevelopTaskDto> dmpDevelopTaskDtos = new ArrayList<DmpDevelopTaskDto>();
		dmpDevelopTasks.stream().forEach(x -> {
			dmpDevelopTaskDtos.add(domain2dto(x));
		});
		
		return dmpDevelopTaskDtos;
	}
	
	public DmpDevelopTask dto2domain(DmpDevelopTaskDto dmpDevelopTaskDto) {
		DmpDevelopTask dmpDevelopTask = new DmpDevelopTask();
		BeanUtils.copyProperties(dmpDevelopTaskDto, dmpDevelopTask);
		
		return dmpDevelopTask;
	}
	
	public List<DmpDevelopTask> dto2domain(List<DmpDevelopTaskDto> dmpDevelopTaskDtos) {
		List<DmpDevelopTask> dmpDevelopTasks = new ArrayList<DmpDevelopTask>();
		dmpDevelopTaskDtos.stream().forEach(x -> {
			dmpDevelopTasks.add(domain2dto(x));
		});
		
		return dmpDevelopTasks;
	}

	/**  
	* @Title: dto2instance  
	* @Description: TODO(将task的job转换成taskInstance)  
	* @param @param dmpDevelopTaskDto
	* @param @param jobId
	* @param @return    参数  
	* @return TaskInstance    返回类型  
	* @throws  
	*/ 
	public TaskInstance dto2instance(DmpDevelopTaskDto dmpDevelopTaskDto, String jobId) {
		TaskInstance taskInstance = new TaskInstance();
		
		return taskInstance;
	}

	/**  
	* @Title: dto2execcontext  
	* @Description: TODO(将task的job转换成taskExecutionContext)  
	* @param @param dmpDevelopTaskDto
	* @param @param jobId
	* @param @return    参数  
	* @return TaskExecutionContext    返回类型  
	* @throws  
	*/ 
	public TaskExecutionContext dto2execcontext(DmpDevelopTaskDto dmpDevelopTaskDto, String jobId) {
		TaskExecutionContext taskExecutionContext = new TaskExecutionContext();
		
		JobType jobType = null;
		if (StringUtils.isEmpty(jobId)) {
			jobType = JobType.valueOf(jobId);
		}
		
		String taskType = dmpDevelopTaskDto.getTaskType();
		if (taskType.equals(CommConstant.TASK_TYPE_DEVSHELL)) {
			jobType = JobType.SHELL;
		}else if (taskType.equals(CommConstant.TASK_TYPE_DEVSQL)) {
			jobType = JobType.SQL;
		}else if (taskType.equals(CommConstant.TASK_TYPE_OFFLINE)) {
			jobType = JobType.SYNC;
		}
		
		switch (jobType) {
		case SHELL:
			taskExecutionContext = ShellParameters.getTaskExecutionContext(dmpDevelopTaskDto);
			break;
		case SQL:
			
			break;
		case SYNC:
			
			break;
		case SUBPROCESS:
			
			break;
		case FTP:
			
			break;
		case UNZIPFILE:
			
			break;
		case DOCTRANS:
			
			break;
		case HDFS:
			
			break;

		default:
			break;
		}
		
		return taskExecutionContext;
	}

}
